//*********************************************************************************
//
//     This program is free software; you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation; either version 2 of the License, or
//     (at your option) any later version.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License along
//    with this program; if not, write to the Free Software Foundation, Inc.,
//    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//    
//    A copy of the GNU General Public License is also available at
//    http://www.fsf.org/licensing/licenses
//
//*********************************************************************************

#include <wx/wx.h>
#include <wx/panel.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/wxprec.h>
#include <wx/string.h>
#include <wx/stattext.h>
#include <wx/gdicmn.h>
#include <wx/font.h>
#include <wx/colour.h>
#include <wx/settings.h>
#include <wx/textctrl.h>
#include <wx/choice.h>
#include <wx/statline.h>
#include <wx/sizer.h>
#include <wx/panel.h>
#include <wx/gauge.h>
#include <wx/button.h>
#include <wx/frame.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/textfile.h>
#include <wx/filename.h>
#include <wx/spinctrl.h>
#include <wx/notebook.h>
#include <list>

class MyCredits : public wxFrame 
{
	private:
	
	protected:
		wxNotebook* m_notebook1;
		wxPanel* m_panel1;
		wxTextCtrl* m_textCtrl1;
		wxPanel* m_panel2;
		wxButton* m_button2;
		wxButton* m_button3;
		wxButton* m_button4;
		wxTextCtrl* m_textCtrl2;
		wxPanel* m_panel3;
		wxTextCtrl* m_textCtrl3;
	
	public:
		
		MyCredits(const wxString& title);
	
};

//*********************************************************************************
//	Definition of the Menu class that houses all GUI elements
//*********************************************************************************
class ThreadInfo;


class MenuBase : public wxFrame 
{
	public:
		
	//*********************************************************************************
	//	Contructor for the MEM Interface 
	//*********************************************************************************
    
		MenuBase(const wxString& title);
		~MenuBase();
	
	//*********************************************************************************
	//	Pointers to the individual menu elements
	//*********************************************************************************
	
		std::list<ThreadInfo> Threadlist;
	
				
		wxNotebook* m_notebook21;
		wxPanel* m_panel2;
		wxStaticText* m_staticText1;
		wxTextCtrl* m_textCtrl1;
		wxButton* m_button1;
		wxTextCtrl* m_textCtrl2;
		wxButton* m_button2;
		wxTextCtrl* m_textCtrl3;
		wxStaticText* m_staticText2;
		wxChoice* m_choice1;
		wxStaticText* m_staticText3;
		wxTextCtrl* m_textCtrl5;
		wxStaticText* m_staticText4;
		wxTextCtrl* m_textCtrl6;
		wxStaticLine* m_staticline1;
		wxStaticText* m_staticText5;
		wxTextCtrl* m_textCtrl7;
		wxStaticText* m_staticText6;
		wxTextCtrl* m_textCtrl8;
		wxStaticText* m_staticText7;
		wxTextCtrl* m_textCtrl9;
		wxStaticLine* m_staticline6;
		wxButton* m_button3;
		wxTextCtrl* m_textCtrl4;
		wxPanel* m_panel3;
		wxStaticText* m_staticText9;
		wxTextCtrl* m_textCtrl11;
		wxStaticText* m_staticText10;
		wxTextCtrl* m_textCtrl12;
		wxStaticText* m_staticText11;
		wxTextCtrl* m_textCtrl13;
		wxStaticText* m_staticText12;
		wxTextCtrl* m_textCtrl14;
		wxStaticText* m_staticText13;
		wxTextCtrl* m_textCtrl15;
		wxStaticLine* m_staticline2;
		wxStaticText* m_staticText14;
		wxTextCtrl* m_textCtrl16;
		wxStaticText* m_staticText15;
		wxTextCtrl* m_textCtrl17;
		wxStaticText* m_staticText16;
		wxTextCtrl* m_textCtrl18;
		wxStaticText* m_staticText17;
		wxTextCtrl* m_textCtrl19;
		wxStaticText* m_staticText18;
		wxTextCtrl* m_textCtrl20;
		wxStaticText* m_staticText19;
		wxTextCtrl* m_textCtrl21;
		wxPanel* m_panel41;
		wxStaticText* m_staticText20;
		wxChoice* m_choice2;
		wxStaticLine* m_staticline3;
		wxStaticText* m_staticText21;
		wxChoice* m_choice3;
		wxStaticText* m_staticText22;
		wxTextCtrl* m_textCtrl22;
		wxStaticText* m_staticText23;
		wxTextCtrl* m_textCtrl23;
		wxStaticText* m_staticText24;
		wxTextCtrl* m_textCtrl24;
		wxStaticText* m_staticText25;
		wxTextCtrl* m_textCtrl25;
		wxStaticText* m_staticText26;
		wxTextCtrl* m_textCtrl26;
		wxStaticText* m_staticText27;
		wxTextCtrl* m_textCtrl27;
		wxPanel* m_panel5;
		wxStaticText* m_staticText28;
		wxChoice* m_choice4;
		wxStaticText* m_staticText35;
		wxChoice* m_choice6;
		wxStaticText* m_staticText29;
		wxTextCtrl* m_textCtrl28;
		wxStaticText* m_staticText36;
		wxTextCtrl* m_textCtrl35;
		wxStaticText* m_staticText31;
		wxTextCtrl* m_textCtrl30;
		wxTextCtrl* m_textCtrl31;
		wxStaticText* m_staticText32;
		wxTextCtrl* m_textCtrl32;
		wxCheckBox* m_checkBox1;
		wxTextCtrl* m_textCtrl34;
		wxStaticLine* m_staticline4;
		wxStaticText* m_staticText37;
		wxTextCtrl* m_textCtrl36;
		wxCheckBox* m_checkBox2;
		wxStaticText* m_staticText38;
		wxTextCtrl* m_textCtrl37;
		wxStaticText* m_staticText39;
		wxTextCtrl* m_textCtrl38;
		wxStaticText* m_staticText40;
		wxTextCtrl* m_textCtrl39;
		wxStaticText* m_staticText41;
		wxTextCtrl* m_textCtrl40;
		wxNotebook* m_notebookTHREAD;
		wxPanel* m_panel4;
		wxTextCtrl* m_textCtrl41;
		wxGauge* m_gauge1;
		wxButton* m_button4;
		
		wxButton* m_button5;
		wxButton* m_button6;
		
		wxButton* m_button7;
		
	//*********************************************************************************
	//	Functions that encode the interaction with the user
	//*********************************************************************************
    
		void SelectDataDir		( wxCommandEvent& event );
		void SelectDataFname	( wxCommandEvent& event );
		void LoadConfig 		( wxCommandEvent& event );
		void SaveConfig 		( wxCommandEvent& event );
		void SelectResultsDir 	( wxCommandEvent& event );
		void RunMEM 		( wxCommandEvent& event );
		void ShowCredits 		( wxCommandEvent& event );
	
};

//*********************************************************************************
//	DEFINITION OF THE MEM WORKER THREAD TO RUN IN THE BACKGROUND OF THE
//	GUI.
//*********************************************************************************
   
    
class MEMWorker : public wxThread
{
    MenuBase* m_parent;
    ThreadInfo* m_ThreadInfo;

  public:
    MEMWorker(MenuBase* parent, ThreadInfo* Info)
    {
        m_parent = parent;
	m_ThreadInfo= Info;
    }
    
    virtual ExitCode Entry();
};

class ThreadInfo
{
  public:

    ThreadInfo()
    {
       threadpanel=0;
        threadtxt=0;
        threadgauge=0;
        threadnotebook=0;
        CurThread=0;	  
		  
    }
	  
    ThreadInfo(ThreadInfo* Info)
    {
        threadpanel=Info->threadpanel;
        threadtxt=Info->threadtxt;
//	fprintf(stderr, "DEBUG CONST %d\n", threadtxt);
        threadgauge=Info->threadgauge;
        threadnotebook=Info->threadnotebook;
        CurThread=Info->CurThread;
    }
	  
    ThreadInfo(const ThreadInfo& Info)
    {
        threadpanel=Info.threadpanel;
        threadtxt=Info.threadtxt;
//	fprintf(stderr, "DEBUG const CONST %d\n", threadtxt);
        threadgauge=Info.threadgauge;
        threadnotebook=Info.threadnotebook;
        CurThread=Info.CurThread;
    }
	  
	  
  wxPanel* threadpanel;
  wxTextCtrl* threadtxt;
  wxGauge* threadgauge;
  MEMWorker* CurThread;  
  wxNotebook* threadnotebook;

};

int MEM_main(int argc,char *argv[], ThreadInfo* TInfo);


MEMWorker::ExitCode MEMWorker::Entry()
{
	
		m_ThreadInfo->CurThread=this;
	
  		wxDateTime starttime = wxDateTime::Now();

// 		fprintf(stderr, "DEBUG GUI BUTTON 1\n");	
// 		fprintf(stderr, "DEBUG %d %d\n", m_ThreadInfo, m_ThreadInfo->threadtxt);
		
	        wxMutexGuiEnter();
		m_ThreadInfo->threadtxt->Clear();
		*m_ThreadInfo->threadtxt<< wxT("MEM started at: ") << starttime.Format() << wxT("\n");
		wxMutexGuiLeave();
		
		int ARGNUM=45;

// 		fprintf(stderr, "DEBUG GUI BUTTON 2\n");
		char** ARGUMENTS;
		ARGUMENTS = new char*[ARGNUM];
		for(int i=0;i<ARGNUM;i++) ARGUMENTS[i] = new char[256];
// 		fprintf(stderr, "DEBUG GUI BUTTON 3\n");
		
		
		wxString separator=wxFileName::GetPathSeparator();
		char tmp[256];
		char tmp2[10];
		strncpy(tmp2, (const char*)separator.mb_str(wxConvUTF8), 10);
		
		strncpy(ARGUMENTS[1], (const char*)m_parent->m_textCtrl7->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[2], (const char*)m_parent->m_textCtrl9->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[3], (const char*)m_parent->m_textCtrl11->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[4], (const char*)m_parent->m_textCtrl12->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[5], (const char*)m_parent->m_textCtrl13->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[6], (const char*)m_parent->m_textCtrl14->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[7], (const char*)m_parent->m_textCtrl16->GetValue().mb_str(wxConvUTF8), 255);
// 		fprintf(stderr, "DEBUG GUI BUTTON 4\n");

		strncpy(ARGUMENTS[8], (const char*)m_parent->m_textCtrl17->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[9], (const char*)m_parent->m_textCtrl18->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[10], (const char*)m_parent->m_textCtrl23->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[11], (const char*)m_parent->m_textCtrl22->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[12], (const char*)m_parent->m_textCtrl36->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[13], (const char*)m_parent->m_textCtrl5->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[14], (const char*)m_parent->m_textCtrl37->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[15], (const char*)m_parent->m_textCtrl6->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[16], (const char*)m_parent->m_textCtrl15->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(tmp, (const char*)m_parent->m_textCtrl2->GetValue().mb_str(wxConvUTF8), 255);
		sprintf(ARGUMENTS[17], "%s%s", tmp,tmp2);
		strncpy(ARGUMENTS[18], (const char*)m_parent->m_textCtrl38->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[19], (const char*)m_parent->m_textCtrl39->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[20], (const char*)m_parent->m_textCtrl40->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[21], (const char*)m_parent->m_textCtrl20->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[22], (const char*)m_parent->m_textCtrl21->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[23], (const char*)m_parent->m_textCtrl19->GetValue().mb_str(wxConvUTF8), 255);
		
		strncpy(ARGUMENTS[24], (const char*)m_parent->m_textCtrl8->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[25], (const char*)m_parent->m_textCtrl24->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[26], (const char*)m_parent->m_textCtrl26->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[27], (const char*)m_parent->m_textCtrl27->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[28], (const char*)m_parent->m_textCtrl25->GetValue().mb_str(wxConvUTF8), 255);
// 		fprintf(stderr, "DEBUG GUI BUTTON 5\n");
		
		if( m_parent->m_choice4->GetSelection() == 0 ){
			sprintf(ARGUMENTS[29], "%d", 10);
		}else if ( m_parent->m_choice4->GetSelection() == 1 ){
			sprintf(ARGUMENTS[29], "%d", 6);
		}else if ( m_parent->m_choice4->GetSelection() == 2 ){
			sprintf(ARGUMENTS[29], "%d", 5);
		}else if ( m_parent->m_choice4->GetSelection() == 3 ){
			sprintf(ARGUMENTS[29], "%d", 2);
		}

		strncpy(ARGUMENTS[30], (const char*)m_parent->m_textCtrl31->GetValue().mb_str(wxConvUTF8), 255);		
		strncpy(ARGUMENTS[31], (const char*)m_parent->m_textCtrl30->GetValue().mb_str(wxConvUTF8), 255);

		strncpy(ARGUMENTS[32], (const char*)m_parent->m_textCtrl32->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[33], (const char*)m_parent->m_textCtrl35->GetValue().mb_str(wxConvUTF8), 255);
		
		
		if( m_parent->m_choice6->GetSelection() == 0 ){
			sprintf(ARGUMENTS[34], "%d", 1);
		}else if ( m_parent->m_choice6->GetSelection() == 1 ){
			sprintf(ARGUMENTS[34], "%d", 0);
		}else if ( m_parent->m_choice6->GetSelection() == 2 ){
			sprintf(ARGUMENTS[34], "%d", 2);
		}
		
		strncpy(ARGUMENTS[35], (const char*)m_parent->m_textCtrl28->GetValue().mb_str(wxConvUTF8), 255);
		
		
		if( m_parent->m_choice3->GetSelection() == 0 ){
			sprintf(ARGUMENTS[36], "%d", 2);
		}else if ( m_parent->m_choice3->GetSelection() == 1 ){
			sprintf(ARGUMENTS[36], "%d", 1);
		}else if ( m_parent->m_choice3->GetSelection() == 2 ){
			sprintf(ARGUMENTS[36], "%d", 3);
		}
// 		fprintf(stderr, "DEBUG GUI BUTTON 6\n");
		
		if( m_parent->m_choice1->GetSelection() == 0 ){
			sprintf(ARGUMENTS[37], "%d", 1);
		}else if ( m_parent->m_choice1->GetSelection() == 1 ){
			sprintf(ARGUMENTS[37], "%d", 2);
		}

		strncpy(ARGUMENTS[38], (const char*)m_parent->m_textCtrl3->GetValue().mb_str(wxConvUTF8), 255);
		
		strncpy(tmp, (const char*)m_parent->m_textCtrl4->GetValue().mb_str(wxConvUTF8), 255);
		sprintf(ARGUMENTS[39], "%s%s", tmp,tmp2);
		
		if( m_parent->m_choice2->GetSelection() == 0 ){
			sprintf(ARGUMENTS[40], "%d", 1);
		}else if ( m_parent->m_choice2->GetSelection() == 1 ){
			sprintf(ARGUMENTS[40], "%d", 2);
		}
// 		fprintf(stderr, "DEBUG GUI BUTTON 7\n");
		
		if( m_parent->m_checkBox1-> GetValue() == 1) {
		 
		    strncpy(ARGUMENTS[41], (const char*)m_parent->m_textCtrl34->GetValue().mb_str(wxConvUTF8), 255);
		    
		} else {
		    
		    sprintf(ARGUMENTS[41], "%d", 0);
		}
		
		
		strncpy(ARGUMENTS[42], (const char*)m_parent->m_textCtrl1->GetValue().mb_str(wxConvUTF8), 255);
		strncpy(ARGUMENTS[43], (const char*)m_parent->m_textCtrl1->GetValue().mb_str(wxConvUTF8), 255);

		if( m_parent->m_checkBox2-> GetValue() == 1) {
		    sprintf(ARGUMENTS[44], "%d", 1);
		} else {
		    sprintf(ARGUMENTS[44], "%d", 0);
		}		
		
			
		MEM_main(ARGNUM,ARGUMENTS, m_ThreadInfo);

		return 0;
}
    
    




//*********************************************************************************
//	Definition of the main application class for use with wxWidgets
//*********************************************************************************

class MEMGui : public wxApp
{
  public:
    virtual bool OnInit();
};


